var emc_carrier;
var emc_carrierInput;

document.addEventListener(
    "DOMContentLoaded", function() {
        emc_parcelPointLinks.init('.select-parcel', emc_getSelectedCarrier, emc_getAddress, emc_setPoint, emc_refreshCarrier);
    }
);

function emc_getSelectedCarrier() {
    return emc_carrier;
}

function emc_getAddress(target) {
    return new Promise(function(resolve, reject) {
        var addressId = target.getAttribute("data-address-id");
        var httpRequest = new XMLHttpRequest();
        httpRequest.onreadystatechange = function() {
            if (httpRequest.readyState === 4) {
                var response = typeof httpRequest.response === 'object' && httpRequest.response !== null ? httpRequest.response : JSON.parse(httpRequest.response);
                if (response.success === false) {
                    reject(emc_lang["Unable to load address"]);
                } else {
                    resolve(response);
                }
            }
        };
        httpRequest.open("POST", emc_ajaxUrlShippingAdmin);
        httpRequest.setRequestHeader(
            "Content-Type",
            "application/x-www-form-urlencoded"
        );
        httpRequest.responseType = "json";
        httpRequest.send("action=emc_get_address&address=" + encodeURIComponent(addressId) + "&security=" + emcShippingAdminAjaxNonce);
    });
}

function emc_setPoint(code, name, carrier) {
    return new Promise(function(resolve, reject) {
        emc_carrierInput.value = code.substring(5);
        resolve();
    });
}

function emc_refreshCarrier(target) {
    return new Promise(function(resolve, reject) {
        emc_carrier = target.getAttribute("data-carrier");
        emc_carrierInput = target.previousSibling;
        resolve();
    });
}
