document.addEventListener(
    "DOMContentLoaded", function() {
        emc_parcelPointLinks.init('.select-parcel', emc_getSelectedCarrier, emc_getAddress, emc_setPoint, emc_refreshCarrier);
    }
);

function emc_getSelectedCarrier() {
    var carrier;
    var uniqueCarrier = document.querySelector('input[type="hidden"].shipping_method');
    if (uniqueCarrier) {
        carrier = uniqueCarrier.getAttribute('value');
    } else {
        var selectedCarrier = document.querySelector('input.shipping_method:checked');
        carrier = selectedCarrier.getAttribute('value');
    }
    return carrier;
}

function emc_getAddress(target) {
    return new Promise(function(resolve, reject) {
        var httpRequest = new XMLHttpRequest();
        httpRequest.onreadystatechange = function() {
            if (httpRequest.readyState === 4) {
                var response = typeof httpRequest.response === 'object' && httpRequest.response !== null ? httpRequest.response : JSON.parse(httpRequest.response);
                if (response.success === false) {
                    reject(emc_lang["Unable to load address"]);
                } else {
                    resolve(response);
                }
            }
        };
        httpRequest.open("POST", emc_ajaxUrl);
        httpRequest.setRequestHeader(
            "Content-Type",
            "application/x-www-form-urlencoded"
        );
        httpRequest.responseType = "json";
        httpRequest.send("action=emc_get_recipient_address");
    });
}

function emc_setPoint(code, name, carrier) {
    return new Promise(function(resolve, reject) {
        var setPointRequest = new XMLHttpRequest();
        setPointRequest.onreadystatechange = function() {
            if (setPointRequest.readyState === 4) {
                var response = typeof setPointRequest.response === 'object' && setPointRequest.response !== null ? setPointRequest.response : JSON.parse(setPointRequest.response);
                if (response.success === false) {
                    reject(response.data.message);
                } else {
                    resolve(name);
                }
            }
        };
        setPointRequest.open("POST", emc_ajaxUrl);
        setPointRequest.setRequestHeader(
            "Content-Type",
            "application/x-www-form-urlencoded"
        );
        setPointRequest.responseType = "json";
        setPointRequest.send("action=emc_set_point&pickup_point_code=" + encodeURIComponent(code)
            + "&pickup_point_name=" + encodeURIComponent(name) + "&carrier_code=" + encodeURIComponent(carrier));
    })
    .then(function(name) {
        var target = document.querySelector("#emc-parcel-client");
        target.innerHTML = name;
    });
}

function emc_refreshCarrier(target) {
    return new Promise(function(resolve, reject) {
        resolve(true);
    });
}
